/***************************************************************************************
 *
 *  IMPORTANT: READ BEFORE DOWNLOADING, COPYING, INSTALLING OR USING.
 *
 *  By downloading, copying, installing or using the software you agree to this license.
 *  If you do not agree to this license, do not download, install, 
 *  copy or use the software.
 *
 *  Copyright (C) 2010-2014, HappyTime Corporation, all rights reserved.
 *
 *  Any copying, transferring or any other usage is prohibited.
 *
****************************************************************************************/

#ifndef PPEXTERN_H
#define PPEXTERN_H

/* user command */
typedef enum puas_cmd
{
	PUCMD_NULL = 0,	
	PUCMD_CALL,
	PUCMD_CONNECT,
	PUCMD_DISCONNECT,	
	PUCMD_MAX
} PUACMD;

/* user event */
typedef enum puas_event
{
	PUEVT_NULL = 0,
	PUEVT_REG_PASS,
	PUEVT_REG_FAIL,
	PUEVT_CALL_IN,
	PUEVT_NOUSER,
	PUEVT_TIMEOUT,
	PUEVT_CONNECT,
	PUEVT_DISCONNECT,
	PUEVT_MAX
} PUAEVT;


typedef void (*PPNTFC)(void * p_userdata, void * sua, PUAEVT evt, void * p_ctx, int len);
typedef void (*PPDATAC)(void * p_userdata, void * sua, void * p_data, int len);

#ifdef __cplusplus
extern "C" {
#endif

/* set basic information 
*/
void 	pp_info_set(const char * server, unsigned short port, const char * user_id);

/* start pp 
*/
bool 	pp_start();

/* stop pp 
*/
void 	pp_stop();

/* start register 
*/
bool 	pp_start_reg();

/* set event notify callback
*/
void 	pp_set_ntf_cb(PPNTFC p_func, void * p_userdata);

/* set data callback 
*/
void 	pp_set_data_cb(PPDATAC p_func);

/* try to connect user 'p_called'
     return the session handle	
*/
void * 	pp_make_call(const char * p_called);

/* end connection session
*/
void 	pp_end_call(void * p_sua);

/* send data
*/
int 	pp_send_data(void * sua, const char * p_data, int len);

/* get remote user name 
*/
char *  pp_get_remote_name(void * sua);

/* get self name
*/
char *  pp_get_self_name(void * sua);


#ifdef __cplusplus
}
#endif

#endif



